//02
unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, StdCtrls, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    soubor1: TMenuItem;
    otevri1: TMenuItem;
    OpenDialog1: TOpenDialog;
    ListBox1: TListBox;
    ListBox2: TListBox;
    Image1: TImage;
    StatusBar1: TStatusBar;
    Label1: TLabel;
    Label2: TLabel;
    GroupBox1: TGroupBox;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    Image2: TImage;
    Napoveda1: TMenuItem;
    Napoveda2: TMenuItem;
    Konec1: TMenuItem;
    N1: TMenuItem;
    procedure otevri1Click(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Image1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure help(sender:TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure Image2Click(Sender: TObject);
    procedure Napoveda2Click(Sender: TObject);
    procedure Konec1Click(Sender: TObject);
    procedure Image1Click(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
uses unit2;
{$R *.dfm}

procedure TForm1.help(sender:TObject); //hinty se zobrazi na statusu = !!!NAPOVEDA
begin
  StatusBar1.Panels[1].Text:=Application.Hint;
end;

procedure TForm1.otevri1Click(Sender: TObject);
begin
  if OpenDialog1.Execute then
  begin
    ///
    ListBox1.Clear;
    listBox2.Clear;
    Image1.Visible:=false;
    image2.Visible:=false;
    caption:='autoAtlas';
    //kdyby to neproslo pred pristi podminku tak by uzivatel nemel nic vydet a nikam klikat
    if lowerCase(ExtractFileExt(OpenDialog1.FileName))<>'.xml' then
    begin
      showmessage('nejedna se o XML zkuste vybrat jiny soubor');
      exit;
    end;
    nacti(OpenDialog1.FileName);
    Caption:='autoAtlas '+OpenDialog1.FileName;
    Image1.Visible:=true;
    GroupBox1.Enabled:=true;
  end;
end;

procedure TForm1.ListBox1Click(Sender: TObject);
var pomX,pomY,cnt:Integer;
begin
  hledejOkolni(ListBox1.Items.Strings[ListBox1.ItemIndex]);
  //sipka ukazuje na mesto(neni vytvarne dokonala)
  posMesta(ListBox1.Items.Strings[ListBox1.ItemIndex],pomx,pomY);
  Image2.Left:=pomX+5;//na spodni dolni roh ukazuje
  Image2.Top:=pomY+5;
  Image2.Visible:=true;
end;

procedure TForm1.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
   if Image1.Canvas.Pixels[x,y]=clBlack then//nema smysl to delat kdyz je barva jina(kurzor neni nad mestem)
     StatusBar1.Panels[0].Text:=jakeMesto(x,y)
   else
     StatusBar1.Panels[0].Text:='';
end;

procedure TForm1.Image1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var nazev:String;
    cnt:Integer;
begin
  if Image1.Canvas.Pixels[x,y]=clBlack then
  begin
    nazev:=jakeMesto(x,y);
    hledejOkolni(nazev);
    for cnt:=0 to ListBox1.Items.Count-1 do     //po kliknuti na mapce se kurzor na listboxu1 presune na mesto
    begin
      if ListBox1.Items.Strings[cnt]=nazev then
      begin
        listbox1.ItemIndex:=cnt;
        exit;
      end;
    end;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Application.OnHint:=help;//kdyz hint tak vypisuju na status
  Application.Title:='autoAtlas';
  caption:='autoAtlas';
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  zobrazMesta;
end;

procedure TForm1.RadioButton2Click(Sender: TObject);
begin
  with image1 do
  begin
    //vymaze obrazovku
    Canvas.brush.Color:=clWhite;
    Canvas.Rectangle(-1,-1,width+1,height+1);
    Canvas.Pen.Color:=clblack;
    Canvas.brush.Color:=clWhite;
  end;
  zobrazMesta;
end;

procedure TForm1.RadioButton1Click(Sender: TObject);
begin
  kresliCesty;
  zobrazMesta;
end;

procedure TForm1.Image2Click(Sender: TObject);
begin
  Image2.Visible:=false;
end;

procedure TForm1.Napoveda2Click(Sender: TObject);
begin
  MessageDlg('Credits k programu autoatlas:'+#13+
             'Vytvoril soutizici c2'+#13+'napoveda ve statusbaru po najeti kurzorem mysi nad ovl. prvek',mtInformation,[mbOk],0);
end;

procedure TForm1.Konec1Click(Sender: TObject);
begin
  form1.Close;
end;

procedure TForm1.Image1Click(Sender: TObject);
begin
  image2.Visible:=false;
end;

end.
