unit Unit2;

interface
uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,unit1;

type TMesto= record
  nazev:string[50];
  x,y:Integer;
end;

type TCesta= record
  z,kam:string[50];
  vzdalenost,prumernaRychlost:Integer;
end;

type TSpotreba = record
  rychlost:Integer;
  litru:Real;
end;


var mesta:array[0..200] of TMesto;
    mesto:integer;  //pocet mest

    cesty:array[0..200] of TCesta;
    cest:Integer;//pocet cest

    spotrebuje:array[0..50] of TSpotreba;
    spotreb:Integer; //pocet rychlosti

    minX,minY,maxX,MaxY:Integer;

procedure nacti(FileName:String); //nacte a nasledne vykresli soubor
procedure hledejOkolni(odMesta:String); //hleda mesta spojene mestem silnicemi
function jakeMesto(x,y:Integer):String; //jake mesto se nachazi na pozici x,y
procedure kresliCesty;                  //vykresli cesty na cele mape
procedure zobrazMesta;                  //zobrazi mesta na mape + popisky
procedure posMesta(jmeno:string; var x,y:Integer);//vysledek jsou pozice na kterych se nachazi mesto

implementation

function jakeMesto(x,y:Integer):String;
var cnt:Integer;
begin
  for cnt:=0 to mesto-1 do
  begin
   if ((abs(mesta[cnt].x+minX-x)<=5) and (abs(mesta[cnt].y+miny-y)<=5)) then //pokud je kurzor nad mestem
   begin
     Result:=mesta[cnt].nazev;
     exit;       //nema cenu dale prohledavat
   end;
  end;
  Result:='';  //kdyz na nic nenarazi tak vysledek = ''
end;

procedure vytipni(co:string); //vytipne tagy spojene se mestem
var cnt,bt,et:integer;
    jmeno,x,y:string;
begin
  bt:=pos('<nazev>',co);
  et:=pos('</nazev>',co);
  jmeno:=copy(co,bt+length('<nazev>'),et-(bt+length('<nazev>')));

  bt:=pos('<polohaX>',co);
  et:=pos('</polohaX>',co);
  x:=copy(co,bt+length('<polohaX>'),et-(bt+length('<polohaX>')));

  bt:=pos('<polohaY>',co);
  et:=pos('</polohaY>',co);
  y:=copy(co,bt+length('<polohaY>'),et-(bt+length('<polohaY>')));

  if StrToInt(x)<minX then minX:=StrToInt(x);
  if StrToInt(y)<minY then minY:=StrToInt(y);

  if StrToInt(x)>maxX then maxX:=StrToInt(x);
  if StrToInt(y)>maxY then maxY:=StrToInt(y);

  mesta[mesto].nazev:=jmeno;
  mesta[mesto].x:=strToInt(x);
  mesta[mesto].y:=strToInt(y);
  inc(mesto);
end;

procedure vytipni2(co:string);//vytipava tagy spojene se spotrebou
var cnt,bt,et:integer;
    rychlost,spotreba:string;
begin
  bt:=pos('<rychlost>',co);
  et:=pos('</rychlost>',co);
  rychlost:=copy(co,bt+length('<rychlost>'),et-(bt+length('<rychlost>')));

  bt:=pos('<litru>',co);
  et:=pos('</litru>',co);
  spotreba:=copy(co,bt+length('<litru>'),et-(bt+length('<litru>')));

  spotrebuje[spotreb].rychlost:=strToInt(rychlost);
  spotrebuje[spotreb].litru:=StrToFloat(spotreba);
  inc(spotreb);
end;

procedure vytipni1(co:string); //a s cestami
var cnt,bt,et:integer;
    kam,z,prumrychlost,vzdalenost:string;
begin
  bt:=pos('<z>',co);
  et:=pos('</z>',co);
  z:=copy(co,bt+length('<z>'),et-(bt+length('<z>')));

  bt:=pos('<do>',co);
  et:=pos('</do>',co);
  kam:=copy(co,bt+length('<do>'),et-(bt+length('<do>')));

  bt:=pos('<vzdalenost>',co);
  et:=pos('</vzdalenost>',co);
  vzdalenost:=copy(co,bt+length('<vzdalenost>'),et-(bt+length('<vzdalenost>')));

  bt:=pos('<prumernaRychlost>',co);
  et:=pos('</prumernaRychlost>',co);
  prumrychlost:=copy(co,bt+length('<prumernaRychlost>'),et-(bt+length('<prumernaRychlost>')));

  cesty[cest].z:=z;
  cesty[cest].kam:=kam;
  cesty[cest].vzdalenost:=strToInt(vzdalenost);
  cesty[cest].prumernaRychlost:=StrToInt(prumrychlost);
  inc(cest);
end;

procedure vypisMesta;//vypise mesta do listboxu1
var cnt:Integer;
begin
  form1.ListBox1.Clear;
  for cnt:=0 to mesto-1 do
  with form1.listBox1.Items do
  begin
    add(mesta[cnt].nazev);
  end;
end;

procedure hledejOkolni(odMesta:String); //hleda okolni mesta
var cnt:Integer;
begin
  Form1.ListBox2.Clear;
  form1.Label1.Caption:='Okolni Mesta pro: '+odMesta;
  for cnt:=0 to cest-1 do
  begin
    if (cesty[cnt].z=odMesta) then
    form1.ListBox2.Items.Add(format('do: %s; delka: %dkm; doba: %fh',[cesty[cnt].kam,cesty[cnt].vzdalenost,(cesty[cnt].vzdalenost / cesty[cnt].prumernaRychlost)]));

    if (cesty[cnt].kam=odMesta) then
    form1.ListBox2.Items.Add(format('do: %s; delka: %dkm; doba: %fh',[cesty[cnt].z,cesty[cnt].vzdalenost,(cesty[cnt].vzdalenost / cesty[cnt].prumernaRychlost)]));
  end;
end;

procedure posMesta(jmeno:string; var x,y:Integer);//vysledek jsou pozice na kterych se nachazi mesto
var cnt:Integer;
begin
 for cnt:=0 to mesto-1 do
 begin
   if mesta[cnt].nazev=jmeno then
   begin
     x:=minX+mesta[cnt].x;   //pokud je pozice mesta napr[-2,-8] tak prictu 2
     y:=minY+mesta[cnt].y;   //..a 8 abych ho dostal na obrazovku
     Exit;
   end;
 end;
end;

procedure popisek(x,y:integer;co:String);//pise popisek k mestu
begin
  with form1.Image1.Canvas do
  begin
    Brush.Color:=clWhite;
    font.Color:=clSkyBlue;//barva neni vyrazna aby vynikla mesta
    Font.Size:=3;
    Font.Height:=3;
    SetBkMode(Handle,TRANSPARENT); //zajistuje transparentnost textu
    TextOut(x-(TextWidth(co)div 2),y+3,co); //popisek pod mesto do prostred
    Brush.Color:=clBlack;
    Pen.Color:=clBlack;
  end;
end;

procedure zobrazMesta;    //vykresluje mesta na mapu
var cnt:Integer;
    pomX,pomY:Integer;
begin
  with form1.Image1.canvas do
  begin
    Brush.Color:=clBlack;
    Pen.Color:=clBlack;
    for cnt:=0 to mesto-1 do
    begin
      posMesta(mesta[cnt].nazev,pomX,pomY);
      popisek(pomX,pomY,mesta[cnt].nazev);
      Rectangle(mesta[cnt].x+minX, mesta[cnt].y+miny, mesta[cnt].x+minX+5, mesta[cnt].y+miny+5);
    end;
  end;
end;

procedure kresliCesty;
var cnt,x,y:Integer;
begin
  for cnt:=0 to cest-1 do
  begin

    form1.Image1.Canvas.Pen.Color:=round(cesty[cnt].prumernaRychlost/120*253)+
                                   +round(cesty[cnt].prumernaRychlost/120*253)*256+
                                   +round(cesty[cnt].prumernaRychlost/120*253)*256*256;
                            //neboli 120km/h je nej rychlost = ma barvu 253 v R a B a G = nejtmavejsi = cesty rozliseny podle barvy
    posMesta(cesty[cnt].kam,x,y);
    form1.Image1.Canvas.MoveTo(x,y);
    posMesta(cesty[cnt].z,x,y);
    form1.Image1.Canvas.LineTo(x,y);
  end;
end;

procedure nacti(FileName:String);
var bT,eT:Integer;
    f:TStrings;
    fs,pom:string;
begin

  f:=TStringList.Create;
  f.LoadFromFile(FileName);
  fs:=f.Text;
  f.Free; //uvolnim stringlist
  mesto:=0;//pocet mest
  cest:=0; //pocet cest
  spotreb:=0;//pocet rychlosi/spotreb

  minX:=100000;
  minY:=100000;
  maxX:=-100000;
  maxY:=-1000000;

  
  if pos('<?xml version="1.0"', fs)=0 then
  begin
   showmessage('nejedna se o XML zkuste vybrat jiny soubor');
   exit;

  end;
  //vzdycky vytipnu blok, ktery pak rozeberu
  while pos('<mesto>',fs)<>0 do
  begin
    bt:=pos('<mesto>',fs);
    et:=pos('</mesto>',fs);
    pom:=copy(fs,bt,et-bt+length('</mesto>'));
    delete(fs,bt,et-bt+length('</mesto>'));
    vytipni(pom);
  end;

  while pos('<cesta>',fs)<>0 do
  begin
    bt:=pos('<cesta>',fs);
    et:=pos('</cesta>',fs);
    pom:=copy(fs,bt,et-bt+length('</cesta>'));
    delete(fs,bt,et-bt+length('</cesta>'));
    vytipni1(pom);
  end;

  while pos('<spotreba>',fs)<>0 do
  begin
    bt:=pos('<spotreba>',fs);
    et:=pos('</spotreba>',fs);
    pom:=copy(fs,bt,et-bt+length('</spotreba>'));
    delete(fs,bt,et-bt+length('</spotreba>'));
    vytipni2(pom);
  end;
  //tady zkousim zda neni nejake mesto mimo mapu
  if minX<0 then minX:=minX*-1
  else minX:=0;
  if MinY<0 then minY:=minY*-1
  else minY:=0;

  vypisMesta;
  zobrazMesta; //a zobrazim a vypisu
end;

end.
